unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms,
  Controls, Graphics, Dialogs, ExtCtrls;

type


  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart1LineSeries2: TLineSeries;
    Chart1LineSeries3: TLineSeries;
    Chart1LineSeries4: TLineSeries;
    Chart1LineSeries5: TLineSeries;
    Chart1LineSeries6: TLineSeries;
    Chart1LineSeries7: TLineSeries;
    CheckGroup1: TCheckGroup;
    procedure CheckGroup1ItemClick(Sender: TObject; Index: integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    fRunning: boolean;
  public
    procedure Start();
  end;

var

  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.CheckGroup1ItemClick(Sender: TObject; Index: integer);
begin
  if not fRunning then Start;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  fRunning := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fRunning := False;
end;

procedure TForm1.Start;
var
  Cnt: cardinal;
  FData: array[0..99] of double;

  procedure PaintNumber(Anr: integer; LS: TLineSeries);
  var
    i: integer;
  begin
    for i := 0 to 99 do
      FData[i] := ((7.5 - ANr) / 3.5 - 1) / 1.2 + Sin(i / 5 + Cnt * ANr / 50) / 5;
    LS.BeginUpdate;
    LS.Clear;
    LS.AddArray(FData);
    LS.EndUpdate;
  end;

begin
  fRunning := True;
  cnt := 0;
  repeat
    if CheckGroup1.Checked[0] then PaintNumber(1, Form1.Chart1LineSeries1);
    if CheckGroup1.Checked[1] then PaintNumber(2, Form1.Chart1LineSeries2);
    if CheckGroup1.Checked[2] then PaintNumber(3, Form1.Chart1LineSeries3);
    if CheckGroup1.Checked[3] then PaintNumber(4, Form1.Chart1LineSeries4);
    if CheckGroup1.Checked[4] then PaintNumber(5, Form1.Chart1LineSeries5);
    if CheckGroup1.Checked[5] then PaintNumber(6, Form1.Chart1LineSeries6);
    if CheckGroup1.Checked[6] then PaintNumber(7, Form1.Chart1LineSeries7);
    Inc(cnt);
    Repaint;
    Application.ProcessMessages;
  until not fRunning;
end;

end.
